/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef debug_h
#define debug_h

#ifdef USE_DEBUG
# include <stdio.h>
# ifdef DEBUG_FILENAME
#  include <fcntl.h>
#  include <sys/stat.h>
#  include <unistd.h>
#  define DEBUG_init() {int fd=open(DEBUG_FILENAME,O_WRONLY|O_CREAT|O_TRUNC,S_IREAD|S_IWRITE);close(2);dup2(fd,2);}
# else
#  define DEBUG_init()
# endif
# ifdef DEBUG_DOMAIN
#  define DEBUG_p(a,...) fprintf(stderr,"DEBUG (" DEBUG_DOMAIN "): %s(): " a "\n",__func__,##__VA_ARGS__)
# elif defined(DEBUG_THREADS)
#  ifdef _WIN32
#   include <windows.h>
#   define DEBUG_p(a,...) fprintf(stderr,"DEBUG (%d): %s(): " a "\n",(int)GetCurrentThreadId(),__func__,##__VA_ARGS__)
#  else
#   include <pthread.h>
#   define DEBUG_p(a,...) fprintf(stderr,"DEBUG (%x): %s(): " a "\n",(int)pthread_self(),__func__,##__VA_ARGS__)
#  endif
# else
#  define DEBUG_p(a,...) fprintf(stderr,"DEBUG: %s(): " a "\n",__func__,##__VA_ARGS__)
# endif
#else
# define DEBUG_init()
# define DEBUG_p(...)
#endif

#endif /* debug_h */
